Redmine - Defect #35441

Inline image in Textile is not displayed if the image URL contains ampersands
2021-06-23 07:19 - Brice Beaumesnil

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Text formatting Estimated time: 0.00 hour
Target version: 422

Resolution: Fixed Affected version: 4.2.1
Description

Hello,

In my projects, i include Sonar Badges (images without extension) in project's description with
[
(textile)

But since redmine 4.2 this include don't work anymore.
| test on new fresh redmine installation too (REDMINE 4.2.1 on ruby 2.7.3) : the same result, no image.

If i tried with markdown format : i have the image.
A Sonar Badget have this format :

https://sonarqube.dev.mydomain/api/project_badges/measure?project=fr.mydomain.myproject%3Amyproject&metric=alert_status :
no file extension (i think it's the problem because if i try an image with an extension, the image is include on the page)

This include works fine in redmine 4.1 and before

thanks

Related issues:

Related to Redmine - Feature #31500: Ruby 2.7 support Closed
Related to Redmine - Defect #29681: "x%x%" is rendered as "&" in Textile form... New

Associated revisions

Revision 21101 - 2021-07-28 10:25 - Go MAEDA

Inline image in Textile is not displayed if the image URL contains ampersands (#35441).

Contributed by Yuichi HARADA.

Revision 21108 - 2021-07-29 01:36 - Go MAEDA
Merged r21101 from trunk to 4.2-stable (#35441).

History

#1 - 2021-06-24 15:14 - Brice Beaumesnil

| tried to see the result here :

4a042b8382a008d344561c8301509f3a?s=32&amp;d=identicon&amp;r=PG
On redmine 4.2.1, the image don't appear, | see all the textile code in place.

'https://www.gravatar.com/avatar/4a042b8382a008d344561c8301509f3a?s=32&d=1identicon&r=PG!

#2 - 2021-06-24 17:51 - Brice Beaumesnil
- File redmine4.2.1-Ruby2.7.3.png added

Test on new installation of REDMINE 4.2.1 on Windows with Ruby 2.7.3

2025-07-01 1/3



https://sonarqube.dev.mydomain/api/project_badges/measure?project=fr.mydomain.myproject%3Amyproject&metric=alert_status

#3 - 2021-06-25 05:09 - Go MAEDA
- Status changed from New to Confirmed
Thank you for reporting the issue. | have confirmed the issue on the latest trunk.

But the latest 4.2-stable branch (including released 4.2.1) is not affected. Maybe you are using the trunk or the master branch of GitHub, aren't you?
Their version number is also "4.2.1" but has ".devel" suffix (e.g. "4.2.1.devel").

#4 - 2021-06-25 10:53 - Brice Beaumesnil
| used github 4.2-stable branch for my install

Environment:

Redmine version 4.2.1.stable

Ruby version 2.7.3-p183 (2021-04-05) [x64-mingw32]
Rails version 5.2.6

Environment production

Database adapter PostgreSQL

Mailer queue ActiveJob::QueueAdapters::AsyncAdapter
Mailer delivery smtp

SCM:

Subversion 1.8.16

Git 2.29.2

Filesystem

Redmine plugins:
no plugin installed

#5 - 2021-07-02 04:57 - Yuichi HARADA
- File 35441.patch added

In the case of Textile, RedCloth3#inline_textile_image(source:/trunk/lib/redmine/wiki_formatting/textile/redcloth3.rb#L 950) is executed to generate the
image tag, but the image could not be displayed because False is returned in Redmine::Helpers::URL#uri_with_safe_scheme?(
source:/trunk/lib/redmine/helpers/url.ro#L 25).

In uri_with_safe_scheme?, the string converted of the input URI (including query string) by RedCloth3#incomming_entries(
source:/trunk/lib/redmine/wiki_formatting/textile/redcloth3.rb#L.1001) is passed as a parameter. However, an error occurred because this conversion
string could not be parsed by URI.parse of source:/trunk/lib/redmine/helpers/url.rb#L31 .

The following patch removes the query string from the conversion string.

diff --git a/lib/redmine/helpers/url.rb b/lib/redmine/helpers/url.rb
index Océ6cbdecd7..40801lee7c8 100644
--— a/lib/redmine/helpers/url.rb
+++ b/lib/redmine/helpers/url.rb
@@ -28,7 +28,7 QR module Redmine
return true unless uri.to_s.include? ":"

# Other URLs need to be parsed
= schemes.include? URI.parse (uri) .scheme

+ schemes.include? URI.parse(uri.split('?').first) .scheme
rescue URI::Error
false
end

#6 - 2021-07-24 01:30 - Go MAEDA

| found that the issue is reproducible when the version of Ruby is 2.7 or higher. This is because URl.parse in Ruby 2.7 or later raises
URI:InvalidURIError if the query string in a given URlI is invalid.

As explained in #35441#note-5, the Textile formatter temporarily replaces "&" in URIs with two "x%" (
source:tags/4.2.1/lib/redmine/wiki_formatting/textile/redcloth3.rb#L. 1001). The conversion makes a URI with a query string malformed. The malformed
URI causes URI::InvalidURIError while checking if the URI scheme is safe at source:tags/4.2.1/lib/redmine/helpers/url.rb#L.31.

It has never caused the reported problem before because URI.parse in Ruby 2.6 or earlier allows URIs with such a malformed query string.

#7 - 2021-07-24 09:17 - Go MAEDA
- File 35441-v2.patch added

- Subject changed from include image without extension failed in redmine 4.2 to Inline image in Textile is not displayed if the image URL contains
ampersands
- Target version set to Candidate for next minor release

Update the patch.
https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/lib/redmine/wiki_formatting/textile/redcloth3.rb#L950
https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/lib/redmine/helpers/url.rb#L25
https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/lib/redmine/wiki_formatting/textile/redcloth3.rb#L1001
https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/lib/redmine/helpers/url.rb#L31
https://www.redmine.org/issues/35441#note-5
https://www.redmine.org/projects/redmine/repository/svn/entry/tags/4.2.1/lib/redmine/wiki_formatting/textile/redcloth3.rb#L1001
https://www.redmine.org/projects/redmine/repository/svn/entry/tags/4.2.1/lib/redmine/helpers/url.rb#L31

e Add a test that describes the issue to ApplicationHelperTest#test_inline_images

e Remove a query string in RedCloth3#inline_textile_image instead of Redmine::Helpers::URL.uri_with_safe_scheme?. This is because the cause
of the issue is the temporary data conversion of RedCloth3#inline_textile_image and Markdown formatter is not affected by the issue at all

¢ Replaced String#split with faster String#partition

#8 - 2021-07-27 11:27 - Go MAEDA

- Target version changed from Candidate for next minor release to 4.2.2
Setting the target version to 4.2.2.

#9 - 2021-07-27 11:31 - Go MAEDA
- Related to Feature #31500: Ruby 2.7 support added

#10 - 2021-07-27 12:51 - Mischa The Evil

| did some research on the background of this change in Ruby to see what changed exactly and why, and if it was an intentional change or a
regression bug.

To summarize:

e |t was an intentional change introduced in Ruby 2.7.x.

o Upstream Ruby issue
o Upstream GitHub commit
e |t was a change to fix a regression introduced in Ruby 2.2.x (so this would not have been an issue when Redmine was running on Ruby <=
2.1.x)
o Upstream GitHub commit

#11 - 2021-07-28 10:27 - Go MAEDA
- Status changed from Confirmed to Resolved
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you for your contribution.

Mischa The Evil wrote:

| did some research on the background of this change in Ruby to see what changed exactly and why, and if it was an intentional change or a
regression bug.

To summarize:

e |t was an intentional change introduced in Ruby 2.7.x.
o Upstream Ruby issue
o Upstream GitHub commit

e |t was a change to fix a regression introduced in Ruby 2.2.x (so this would not have been an issue when Redmine was running on Ruby <=
2.1.x)

o Upstream GitHub commit

Thank you for your detailed investigation.

#12 - 2021-07-29 01:37 - Go MAEDA

- Status changed from Resolved to Closed

#13 - 2021-08-04 17:37 - Mischa The Evil

- Related to Defect #29681: "x%x%" is rendered as "&" in Textile formatter added

Files

redmine4.2.1-Ruby2.7.3.png 22.9 KB 2021-06-24 Brice Beaumesnil
35441 .patch 1.28 KB 2021-07-02 Yuichi HARADA
35441-v2.patch 1.43 KB 2021-07-24 Go MAEDA
https://bugs.ruby-lang.org/issues/11275
